package sample.efpo;

import java.util.*;

public class Flow_net_2 {
	private double[] alphas;
	private double[] prices;
	private boolean[][] edges;
	private boolean[][] edges2;
	private double[][] edgesCap; 
	private Vector<Integer> S_plus, S_zero, S_minus, J_plus, J_zero, J_minus;
	private double minCutValue;
	
	public Flow_net_2(double[] a,double[] p, boolean[][] e)
	{
		alphas = copyDoubleArr(a);
		prices = copyDoubleArr(p);
		edges = copyBooleanSquareArr(e);
		edgesCap = new double[alphas.length][prices.length];
		S_plus = new Vector<Integer> ();
		S_zero = new Vector<Integer> ();
		S_minus = new Vector<Integer> ();
		J_plus = new Vector<Integer> ();
		J_zero = new Vector<Integer> ();
		J_minus = new Vector<Integer> ();
		minCutValue = getMinCutVal();
	}
	
	public Flow_net_2(double[] a,double[] p, boolean[][] e, boolean[][] e2)
	{
		alphas = copyDoubleArr(a);
		prices = copyDoubleArr(p);
		edges = copyBooleanSquareArr(e);
		edges2 = copyBooleanSquareArr(e2);
		edgesCap = new double[alphas.length][prices.length];
		S_plus = new Vector();
		S_zero = new Vector();
		S_minus = new Vector();
		J_plus = new Vector();
		J_zero = new Vector();
		J_minus = new Vector();
		minCutValue = getMinCutVal();
	}
	
	public double getMinCutValue()
	{
		return minCutValue;
	}
	
	public double getMinCutVal()
	{
		double ans = 0;
		boolean[][] minCut = getMinCut();
	//	for (int i = 0; i < alphas.length; i++)
		//	if(minCut[0][i])
		for (int i = 0; i < alphas.length; i++)
			for (int j = 0; j < prices.length; j++)
				ans = ans + edgesCap[i][j];
		//for (int i = 0; i < prices.length; i++)
		//	if(minCut[1][i])
		//		ans = ans + prices[i];
		return ans;
	}
	
	public Vector<Integer> getS_plus()
	{
		return S_plus;
	}
	
	public Vector<Integer> getS_zero()
	{
		return S_zero;
	}
	
	public Vector<Integer> getS_minus()
	{
		return S_minus;
	}
	
	public Vector<Integer> getJ_plus()
	{
		return J_plus;
	}
	
	public Vector<Integer> getJ_zero()
	{
		return J_zero;
	}
	
	public Vector<Integer> getJ_minus()
	{
		return J_minus;
	}
	
	private boolean[][] getMinCut()
	{
		//System.out.println("starting get min cut");
		//hello.printDoubleArray(alphas);
		//hello.printDoubleArray(prices);
		boolean[][] ans;
		double[] recP = copyDoubleArr(prices);
		double[] recA = copyDoubleArr(alphas);
		ans = getMinCutRec(recA,recP);
		//System.out.println("min cut = ");
		//hello.printBooleanDoubleArray(ans);
		return ans;
	}
	
	public double[][] getAlloc()
	{
		System.out.println("starting get alloc");
		//hello.printDoubleArray(alphas);
		hello.printDoubleArray(prices);
		hello.printDoubleDoubleArray(edgesCap);
		double[][] ans;
		//double[] recP = copyDoubleArr(prices);
		//double[] recA = copyDoubleArr(alphas);
		ans = new double[alphas.length][prices.length];
		//getAllocRec(recA,recP,ans);
		for(int i = 0; i < alphas.length; i++)
			for(int j = 0; j < prices.length;j++)
				ans[i][j] = edgesCap[i][j]/prices[j];
			
		System.out.println("alloc = ");
		hello.printDoubleDoubleArray(ans);
		return ans;
	}
	
	private static double[] copyDoubleArr(double[] d)
	{
		double[] ans = new double[d.length];
		for (int i = 0;i < d.length;i++)
			ans[i] = d[i];
		return ans;
	}
	
	private static boolean[][] copyBooleanSquareArr(boolean[][] db)
	{
		//System.out.println("db.length - "+ db.length);
		//System.out.println("db[0].length - "+ db[0].length);
		//hello.printBooleanDoubleArray(db);
		boolean[][] ans = new boolean[db.length][db[0].length];
		for (int i = 0;i < db.length;i++)
		{
			//System.out.println(i);
			//System.out.println(db[i].length);
			for (int j = 0;j < db[i].length;j++)
				ans[i][j] = db[i][j];
		}
		return ans;
	}
	
	private boolean[][] getMinCutRec(double[] recA, double[] recP)
	{
		//System.out.println("starting rec get min cut");
		//hello.printDoubleArray(recA);
		//hello.printDoubleArray(recP);
		int minArc = getMinArc(recA,recP);
		//System.out.println("minArc = " + minArc);
		if (minArc >= 0)
			updateArcs(minArc,recA,recP);
		else
		{
			if(! improvePath(recA,recP))
				return getFinalCut(recA,recP);
		}
		return getMinCutRec(recA,recP);
	}
	/*
	private void getAllocRec(double[] recA, double[] recP, double[][] ans)
	{
		//System.out.println("starting rec get min cut");
		//hello.printDoubleArray(recA);
		//hello.printDoubleArray(recP);
		int minArc = getMinArc(recA,recP);
		//System.out.println("minArc = " + minArc);
		if (minArc >= 0)
		{
			updateArcs(minArc,recA,recP,ans);
			getAllocRec(recA,recP,ans);
		}
	}
	*/
	private boolean improvePath(double[] recA, double[] recP)
	{
//		System.out.println("starting improve path");
//		hello.printDoubleArray(recA);
//		hello.printDoubleArray(recP);
		//hello.printBooleanDoubleArray(edges);
//		int arc = 100;
//		int source = -1;
		for(int i = 0; i < recA.length;i++)
			if(recA[i] > 0)
				{
				//System.out.println("first loop ");
					for(int j = 0; j < recP.length;j++)
					{
						//System.out.println("first loop ");
						if(recP[j] > 0)
							if(existPath(i, j, recA, recP))
							{
								//System.out.println("second loop");
								//hello.printDoubleArray(recA);
								//hello.printDoubleArray(recP);
								return true;
							}
					}
				}
		//System.out.println("did not improve path");
		return false;
	}
	
	private boolean existPath(int source, int target, double[] recA, double[] recP)
	{
//		System.out.println("started exists path with " + source + ", " +target);
		Vector<Integer> Q = new Vector<Integer>();
		TreeMap<Integer,Integer> dads = new TreeMap<Integer,Integer>();
		Q.add(source);
		dads.put(source,source);
		while(Q.size() > 0)
		{
//			System.out.println("Q: " + Q);
	//		System.out.println("dads: " + dads);
			int node = Q.remove(0);
			if(node < recA.length)
			{
				for(int i = 0; i < recP.length; i++)
					if (isValidEdge(node,i) && !dads.containsKey(i+recA.length))
					{
						Q.add(i+recA.length);
						dads.put(i+recA.length,node);
					}
			}
			else
			{
				for(int i = 0; i < recA.length; i++)
					if (edgesCap[i][node - recA.length] > 0 && !dads.containsKey(i))
					{
						Q.add(i);
						dads.put(i,node);
					}
			}
		}
		if(dads.containsKey(target+recA.length))
		{
			double pathCap = recP[target];
//			System.out.println("pathCap init to: " + pathCap);
			int curr = target+recA.length;
	//		System.out.println("dads: " + dads);
	//		System.out.println("curr =  " + curr);
			while (dads.get(curr)!= source)
			{
			//	System.out.println(" in loop pathCap: " + pathCap + ", curr: " + curr);
				//curr = dads.get(curr);
				//System.out.println(" after updating curr: " + curr);
				if(curr >= alphas.length)
				{
					if(prices[curr - alphas.length] < pathCap)
						pathCap = prices[curr - alphas.length];
					//if(edgesCap[dads.get(curr)][curr - alphas.length] < pathCap)
						//pathCap = edgesCap[dads.get(curr)][curr - alphas.length];
				}		
				else		
				{		
					if(alphas[curr] < pathCap)
							pathCap = alphas[curr];
					if(edgesCap[curr][dads.get(curr) - alphas.length] < pathCap)
						pathCap = edgesCap[curr][dads.get(curr) - alphas.length];
				}	
				curr = dads.get(curr);
			}		
			//System.out.println("found pathCap: " + pathCap);
			curr = dads.get(curr);
			//System.out.println("final curr =  " + curr);
			if(recA[source] < pathCap)
				pathCap = recA[curr];
			if(pathCap == 0)
				return false;
			curr = target + alphas.length;
		//	hello.printDoubleDoubleArray(edgesCap);
			while (curr!= source)
			{
				if(curr >= alphas.length)
				{
	//				System.out.println("edgesCap before update1: " + curr);
	//				hello.printDoubleDoubleArray(edgesCap);
					edgesCap[dads.get(curr)][curr - alphas.length] += pathCap;
	//				System.out.println("edgesCap after update: " + pathCap);
	//				hello.printDoubleDoubleArray(edgesCap);
				}
				else
				{
		//			System.out.println("edgesCap before update2: " + curr);
		//			hello.printDoubleDoubleArray(edgesCap);
					edgesCap[curr][dads.get(curr) - alphas.length] -= pathCap;
		//			System.out.println("edgesCap after update: " + pathCap);
		//			hello.printDoubleDoubleArray(edgesCap);
				}
				curr = dads.get(curr);
			}
			recP[target] = recP[target] - pathCap;
			recA[source] = recA[source] - pathCap;
			//System.out.println("before exit pathCap: " + pathCap);
			//hello.printDoubleDoubleArray(edgesCap);
			//System.exit(0);
			return true;
		}
		return false;
	}
		
	
	
	private boolean[][] getFinalCut(double[] recA, double[] recP)
	{
		//System.out.println("starting getFinalCut");
		hello.printDoubleArray(recA);
		hello.printDoubleArray(recP);
		hello.printBooleanDoubleArray(edges);
		hello.printDoubleDoubleArray(edgesCap);
		boolean ans[][] = new boolean[2][Math.max(recA.length, recP.length)];
		for(int i = 0; i < recA.length;i++)
		{
			if(recA[i] == 0)
			{
				ans[0][i] = true;
				if(canReachEnd(i,recA,recP))
					S_minus.add(new Integer(i));
				else
				{
					if(reachable(i,recA,recP))
						S_plus.add(new Integer(i));
					else
						S_zero.add(new Integer(i));
				}
			}
			else
				S_plus.add(new Integer(i));
		}
		for(int i = 0; i < recP.length;i++)
		{
			if(recP[i] == 0)
			{
				if(reachable(i+recA.length,recA,recP))
				{
					ans[1][i] = true;
					J_plus.add(new Integer(i));
				}
				else
				{
					if(canReachEnd(i+recA.length,recA,recP))
						J_minus.add(new Integer(i));
					else
						J_zero.add(new Integer(i));
				}
			}
			else 
				J_minus.add(new Integer(i));
		}
		/*
		Vector<Integer> remove = new Vector<Integer> ();
		Iterator<Integer> iter = J_zero.iterator();
		while(iter.hasNext())
		{
			int zero = iter.next();
			Iterator<Integer> iter_minus = J_minus.iterator();
			while(iter_minus.hasNext())
			{
				int minus = iter_minus.next();
				if(existPath_func(minus,zero,recA,recP))
					remove.add(zero);
			}
		}
		iter = remove.iterator();
		while (iter.hasNext())
		{
			Integer i = iter.next();
			J_zero.remove(i);
			J_minus.add(i);
		}
		
		remove = new Vector<Integer> ();
		iter = S_zero.iterator();
		while(iter.hasNext())
		{
			int zero = iter.next();
			Iterator<Integer> iter_plus = S_plus.iterator();
			while(iter_plus.hasNext())
			{
				int plus = iter_plus.next();
				if(existPath_func(zero,plus,recA,recP))
					remove.add(zero);
			}
		}
		iter = remove.iterator();
		while (iter.hasNext())
		{
			Integer i = iter.next();
			S_zero.remove(i);
			S_plus.add(i);
		}
		*/		
		//System.out.println("FinalCut:");
		//hello.printBooleanDoubleArray(ans);	
		//System.out.println("printing S's: ");
		//System.out.println(S_plus);
		//System.out.println(S_zero);
		//System.out.println(S_minus);
		//System.out.println("printing J's: ");
		//System.out.println(J_plus);
		//System.out.println(J_zero);
		//System.out.println(J_minus);
		return ans;
	}
	
	private int getMinArc(double[] recA,double[] recP)
	{
		//System.out.println("starting getMinArc");
		//hello.printDoubleArray(recA);
		//hello.printDoubleArray(recP);
		double min = 1;
		int ind = -1;
		for(int i = 0; i < recA.length;i++)
		{
			if (recA[i] > 0 && recA[i] < min)
			{
				for(int j = 0; j < recP.length; j++)
					if(isValidEdge(i,j) && recP[j] > 0)
					{
						min = recA[i];
						ind = i;
						break;
					}
			}
		}
		for(int i = 0; i < recP.length;i++)
		{
			if (recP[i] > 0 && recP[i] < min)
			{
				//System.out.println("got here with i: " + i);
				for(int j = 0; j < recA.length; j++)
				{
					//System.out.println("got here with j: " + j + edges[j][i]);
					if(isValidEdge(j,i) && recA[j] > 0)
					{
						min = recP[i];
						ind = i + recA.length;
						break;
					}
				}
			}
		}
		return ind;
	}
	/*
	private int getMinArc(double[] recA,double[] recP)
	{
		System.out.println("starting getMinArc");
		hello.printDoubleArray(recA);
		hello.printDoubleArray(recP);
		double min = 1;
		int ind = -1;
		for(int i = 0; i < recA.length;i++)
		{
			if (recA[i] > 0)
			{
				for(int j = 0; j < recP.length; j++)
					if(isValidEdge(i,j) && recP[j] > 0)
					{
						if(recA[i] < recP[j])
						{
						//min = recA[i];
							ind = i;
						}
						else
							ind = j + recA.length;
						break;						
					}
			}
		}
	}
	*/
	private double getArcCap(int minArc,double[] recA,double[] recP)
	{
		double ans = 0;
		if(minArc >= recA.length)
			ans = recP[minArc - recA.length];
		else
			ans =  recA[minArc];
		return ans;
	}
	
	private void updateArcs(int minArc,double[] recA,double[] recP)
	{
		//System.out.println("updating arc: " + minArc);
		if(minArc >= recA.length)
		{
			int ind = minArc - recA.length;			
			for(int i = 0; i < recA.length; i++)
				if(isValidEdge(i,ind) && recA[i] > 0)
				{
					recA[i] = recA[i] - recP[ind];
					edgesCap[i][ind] = recP[ind];
					break;
				}
			recP[ind] = 0;
		}
		else
		{
			int ind = minArc;			
			for(int i = 0; i < recP.length; i++)
				if(isValidEdge(ind,i) && recP[i] > 0)
				{
					edgesCap[ind][i] = recA[ind];
					recP[i] = recP[i] - recA[ind];
					break;
				}
			recA[ind] = 0;
		}
			
	}
	
	private void updateArcs(int minArc,double[] recA,double[] recP, double[][] ans)
	{
		if(minArc >= recA.length)
		{
			int ind = minArc - recA.length;			
			for(int i = 0; i < recA.length; i++)
				if(isValidEdge(i,ind) && recA[i] > 0)
				{
					recA[i] = recA[i] - recP[ind];
					ans[i][ind] = recP[ind]/prices[ind];
					break;
				}
			recP[ind] = 0;
		}
		else
		{
			int ind = minArc;			
			for(int i = 0; i < recP.length; i++)
				if(isValidEdge(ind,i) && recP[i] > 0)
				{
					recP[i] = recP[i] - recA[ind];
					ans[ind][i] = recA[ind]/prices[i];
					break;
				}
			recA[ind] = 0;
		}
			
	}
	
	private boolean reachable(int priceInd, double[] recA, double[] recP)
	{
		//System.out.println("starting reachable" );
		for(int i = 0; i < recA.length; i++)
			if(recA[i] > 0 && existPath_func(priceInd, i, recA, recP))
			{
				//System.out.println("reachable returns true" );	
				return true;
			}
		//System.out.println("reachable returns false" );	
		return false;
	}
	
	private boolean canReachEnd(int alphaInd, double[] recA, double[] recP)
	{
		//System.out.println("starting canReachEnd" );
		//hello.printDoubleDoubleArray(edgesCap);
		for(int i = 0; i < recP.length; i++)
			if(recP[i] > 0 && existPath_func(alphaInd, i + recA.length,recA,recP))
			{
				//System.out.println("canReachEnd returns true" );
				return true;
			}
		//System.out.println("canReachEnd returns false" );
		return false;
	}
	
	private boolean existPath_func(int source, int target, double[] recA, double[] recP)
	{
		//System.out.println("started exists path func with " + source + ", " +target);
		Vector<Integer> Q = new Vector<Integer>();
		TreeMap<Integer,Integer> dads = new TreeMap<Integer,Integer>();
		Q.add(source);
		dads.put(source,source);
		while(Q.size() > 0)
		{
			//System.out.println("Q: " + Q);
			//System.out.println("dads: " + dads);
			int node = Q.remove(0);
			if(node < recA.length)
			{
				for(int i = 0; i < recP.length; i++)
					if (edgesCap[node][i]>0 && !dads.containsKey(i+recA.length))
					{
						Q.add(i+recA.length);
						dads.put(i+recA.length,node);
					}
			}
			else
			{
				for(int i = 0; i < recA.length; i++)
					if (edgesCap[i][node - recA.length] > 0 && !dads.containsKey(i))
					{
						Q.add(i);
						dads.put(i,node);
					}
			}
		}
		if(dads.containsKey(target))
		{
			//System.out.println("exists path func returns true");	
			return true;
		}
		//System.out.println("exists path func returns false");	
		return false;
	}
	
	public Vector<Vector<Pair>> cyclesContaining(int ind)
	{
		double maxCycleVal = 0;
		Graph gAlloc = new Graph();
		Vector<Pair> vertexes = new Vector<Pair> ();
		for(int i = 0; i < alphas.length;i++)
		{
			for(int j = 0; j < prices.length; j++)
			{
				if(edgesCap[i][j] > 0)
				{
					gAlloc.addVertex(new Pair(i,j));
					vertexes.add(new Pair(i,j));
				//	gAlloc.addVertex(new Pair(i,j,1));
				//	vertexes.add(new Pair(i,j,1));
				}
			}
		}
		//System.out.println("vertexes: " + vertexes);
		Iterator<Pair> iter = vertexes.iterator();
		while(iter.hasNext())
		{
			Pair trip = iter.next();
			Iterator<Pair> iter2 = vertexes.iterator();
			while(iter2.hasNext())
			{
			//	System.out.println("got here 2");
				Pair trip2 = iter2.next();
			//	System.out.println("trips: "+ trip + trip2);
				if(trip.getFirst() != trip2.getFirst())
					{
				//		System.out.println("adding edg: " + trip + trip2);
						gAlloc.addEdge(trip, trip2);
					}
				
			}
		}
		
		Vector<Vector<Pair>> cycles = gAlloc.getCyclesContaining(ind);
		removeInvalidCycles(cycles);
		//System.out.println("finishing maxUtilReduction");
		//System.out.println(cycles);
		
		return cycles;		
	}
	
	public void removeInvalidCycles(Vector<Vector<Pair>> cycles)
	{
		//Vector<Pair> cycle;
		Iterator<Vector<Pair>> iter_cycle = cycles.iterator();
		while (iter_cycle.hasNext())
		{
			if(isValidCycle(iter_cycle.next()))
			{
	//			System.out.println("removing cycle");
				iter_cycle.remove();
			}
		}
	}
	
	public boolean isValidCycle(Vector<Pair> cycle)
	{
		return hasSingleItem(cycle) || moreThanOnceHolder(cycle);
	}
	
	public boolean hasSingleItem(Vector<Pair> cycle)
	{
	//	System.out.println("starting has single item");
	//	System.out.println("cycle: " + cycle);
		int item;
		Pair p = cycle.get(0);
		item = p.getSecond();
		Iterator<Pair> iter_pair = cycle.iterator();
		while (iter_pair.hasNext())
		{
			p = iter_pair.next();
			if(p.getSecond() != item)
				return false;
		}
		//System.out.println("starting has single item returning true");
		return true;
	}
	
	public boolean moreThanOnceHolder(Vector<Pair> cycle)
	{
	//	System.out.println("starting more than once holder");
	//	System.out.println("cycle: " + cycle);
		Vector<Integer> holders = new Vector<Integer> ();
		Pair p = cycle.get(0);
		Iterator<Pair> iter_pair = cycle.iterator();
		while (iter_pair.hasNext())
		{
			p = iter_pair.next();
			if(holders.contains(p.getSecond()))
				return true;
			else
				holders.add(p.getSecond());
		}
		return false;
	}
	
	private boolean isValidEdge(int i, int j)
	{
	//	System.out.println("starting is valid edge with i = " + i + ", j = " + j );
		boolean ans = false;
		if(edges[i][j])
			ans = true;
		else
		{
			boolean comp = true;
			for(int k = 0; k < edges[i].length; k++)
			{
				//System.out.println("edgesCap["+i+"]["+k+"] = " + edgesCap[i][k]);
				if(edges[i][k] && edgesCap[i][k]/prices[k] < 0.99999999)
				{
					
					//System.out.println("changing comp to false");
					comp = false;
				}
			}
		//	System.out.println("edges2["+i+"]["+j+"] = " + edges2[i][j] );
			if(comp && edges2[i][j])
				ans = true;
		}
		//System.out.println("is valid edge "+ ans);
		return ans;					
	}
			
		
}
