package mypackage;

import java.util.*;

public class EFPO {
	
	double[][] U;
	double[] alphas;
	double[] prices;
	double[] M;
	boolean[][] edges;
	double PJ_plus,PJ_minus;
	int[] types;
	double[][] maxReductions;
	double tax_epsilon;
	int rec;
	Flow_net FN;
	final boolean debug = false;
	
	public EFPO( double[][] u)
	{
		U = copyDoubleSquareArr(u);
		tax_epsilon = 0.2;
		FN = null;
		rec = 0;
	}
	
	public double[][] getAlloc_heu()
	{
	    double[][] alloc = getAlloc(true);
		//while(canReduce())
		//{
	    //alloc = getAlloc(true);
			//}
		return alloc;
	}
	
	public double[][] getAlloc(boolean red)
	{
		rec++;
		//System.out.println("U:");
		//hello.printDoubleDoubleArray(U);
		
		//Flow_net FN = null;
		getMinCutVal();
		
		double[][] alloc = FN.getAlloc();
		if(debug)
		{
			System.out.println("firstalloc:");
			hello.printDoubleDoubleArray(alloc);
		}
		
		//maxReductions = getMaxReductions(FN);
		//System.out.println("max reductions:");
		//hello.printDoubleDoubleArray(maxReductions);
		
		types = getTypes(FN);
		if(debug)
		{
			System.out.print("types: ");
			hello.printArray(types);
		}
		boolean[] complete_alloc = new boolean[prices.length];
		double red_factor = 0;
		if(red && types[hello.agent] == 1)
		{
			//System.out.print("here!!!");
			if(debug)
				System.out.println("operating heuristic");
			alloc = FN.getAlloc();
			//System.out.println("original alloc");
			//hello.printDoubleDoubleArray(alloc);
			//double max_red = 100;
			//int red_ind = -1;
			for(int loopi = 0; loopi < alloc[hello.agent].length; loopi++)
			    if(alloc[hello.agent][loopi] > 0.9999999)
				{
				    getMaxReductions(hello.agent,loopi);
				    //int red_ind = loopi;
				    //red_factor = ( U[hello.agent][loopi] - max_red) / U[hello.agent][red_ind];
				    //if(red_factor > 1)
				    complete_alloc[loopi] = true;
				    //U[hello.agent][loopi] = U[hello.agent][loopi]* red_factor;
				}
			if(debug)
			    {
				System.out.println("new U:");
				hello.printDoubleDoubleArray(U);
			    }
			getMinCutVal();
			//return getAlloc(false);
			
			alloc = FN.getAlloc();
			if(debug)
			    {
				System.out.println("second alloc:");
				hello.printDoubleDoubleArray(alloc);
			    }
			//boolean heu_fix = true;
			int count_while = 0;
			while(red && !checkAlloc(complete_alloc,alloc))
			    {
				for(int loopi = 0; loopi < alloc[hello.agent].length; loopi++)
				    {
					if(complete_alloc[loopi] && alloc[hello.agent][loopi] < 0.99999999)
					    {
						U[hello.agent][loopi] = U[hello.agent][loopi]* 1.01;
					    }
				    }
				if(debug)
				    {
					System.out.println("loop U2:");
					hello.printDoubleDoubleArray(U);
				}
				getMinCutVal();
				
				alloc = FN.getAlloc();
				if(debug)
				{
					System.out.println("alloc:");
					hello.printDoubleDoubleArray(alloc);
				}
				if(count_while == 2000)
				{
					System.out.println("exiting");
					System.exit(0);
				}
				else
					count_while++;
				
			}
			boolean[] increased = new boolean[complete_alloc.length];
			while(red && checkAlloc(complete_alloc,alloc) && existIncAlloc(complete_alloc,alloc))
			{
				for(int loopk = 0; loopk < increased.length;loopk++)
					increased[loopk] = false;
				for(int loopi = 0; loopi < alloc[hello.agent].length; loopi++)
				{
					if(!complete_alloc[loopi] && alloc[hello.agent][loopi] < 0.99999999 && alloc[hello.agent][loopi] > 0)
					{
						U[hello.agent][loopi] = U[hello.agent][loopi]* 1.01;
						increased[loopi] = true;
					}
				}
				if(debug)
				{
					System.out.println("loop U3:");
					hello.printDoubleDoubleArray(U);
				}
				getMinCutVal();
				
				alloc = FN.getAlloc();
				
				if(debug)
				{
					System.out.println("alloc:");
					hello.printDoubleDoubleArray(alloc);
				}
				if(count_while == 2000)
				{
					System.out.println("exiting");
					System.exit(0);
				}
				else
					count_while++;
				
			}
			
			for(int loopi = 0; loopi < alloc[hello.agent].length; loopi++)
			{
				if(increased[loopi])
				{
					U[hello.agent][loopi] = U[hello.agent][loopi]* 1/1.01;
				}
			}
			getMinCutVal();
			alloc = FN.getAlloc();
		}
		
		if((red && rec < 5 && !existIncAlloc(complete_alloc,alloc)))
			return getAlloc(true);
		
		if(debug)
		{
			System.out.println("third alloc:");
			hello.printDoubleDoubleArray(alloc);
		}
		
		
		/*
		count_while = 0;
		for(int loopi = 0; loopi < prices.length; loopi++)
		{
			heu_fix = true;
			while(red && heu_fix)
			{
				heu_fix = false;
				if(complete_alloc[loopi] && alloc[hello.agent][loopi] > 0.99999999)
				{
					U[hello.agent][loopi] = U[hello.agent][loopi]* 0.999;
					heu_fix = true;
				//System.out.println("loop U2:");
				//hello.printDoubleDoubleArray(U);
					getMinCutVal();
				
					alloc = FN.getAlloc();
				
				//System.out.println("alloc:");
				//hello.printDoubleDoubleArray(alloc);
				}
			}
				if(complete_alloc[loopi])
				{
					U[hello.agent][loopi] = U[hello.agent][loopi]* 1/0.999;
				//System.out.println("loop U2 final:");
				//hello.printDoubleDoubleArray(U);
					getMinCutVal();
			
					alloc = FN.getAlloc();
				}
			if(count_while == 2000)
			{
				System.out.println("exiting 2");
				System.exit(0);
			}
			else
				count_while++;
				
		}
		//System.out.println("edgesCap:");
		System.out.println("alloc:");
		hello.printDoubleDoubleArray(alloc);
		
		*/
		//System.out.print(".");
		return alloc;
	}
	
	private void getMinCutVal()
	{
		alphas = getAlphas(U);
		prices = getInitPrices(U);
		int count = 0;
		double minCutVal = 0;
		while( minCutVal < 0.999999)
		{
			//System.out.println("minCutVal: " + minCutVal);
			
			//System.out.print("prices: ");
			//hello.printDoubleArray(prices);
			M = getMArr(prices, U);
			//System.out.print("M: ");
			//hello.printDoubleArray(M);
			edges = getEdges(prices, M, U);
			
			//System.out.print("first call to FN ");
			FN = new Flow_net(alphas,prices,edges);
			minCutVal = FN.getMinCutValue();
			Vector<Integer> S_plus = FN.getS_plus();
			Vector<Integer> S_zero = FN.getS_zero();
			Vector<Integer> S_minus = FN.getS_minus();
			Vector<Integer> J_plus = FN.getJ_plus();
			Vector<Integer> J_zero = FN.getJ_zero();
			Vector<Integer> J_minus = FN.getJ_minus();
			
			//System.out.println("S_plus: " + S_plus);
			//System.out.println("S_zero: " + S_zero);
			//System.out.println("S_minus: " + S_minus);
			PJ_plus = getPJ(J_plus);
		//	System.out.println("J_plus: " + J_plus);
		//	System.out.println("J_zero: " + J_zero);
			PJ_minus = getPJ(J_minus);
		//	System.out.println("J_minus: " + J_minus);
		//	System.out.println("PJ_plus: " + PJ_plus);
		//	System.out.println("PJ_minus: " + PJ_minus);
			
			double epsilon1 = 100;
			epsilon1 = Math.min(epsilon1, getEpsilon1_plus_zero(S_plus,J_zero));
			epsilon1 = Math.min(epsilon1, getEpsilon1_zero_minus(S_zero,J_minus));
			epsilon1 = Math.min(epsilon1, getEpsilon1_plus_minus(S_plus,J_minus));
			
			double epsilon2 = getEpsilon2(S_minus,J_minus);
			
			double epsilon = Math.min(epsilon1, epsilon2);
			//System.out.println("epsilon1: " + epsilon1);
			//System.out.println("epsilon2: " + epsilon2);
			//System.out.println("epsilon: " + epsilon);
			
			updateJ_plus(J_plus,epsilon);
			updateJ_minus(J_minus,epsilon);
			
			
			//hello.printDoubleArray(alphas);
			
			//hello.printDoubleArray(M);
			//hello.printBooleanDoubleArray(edges);
			//System.out.print("epsilon1: " + epsilon1);
			if (count == 2000)
			{
				//return null;
				System.out.println("exiting");
				System.exit(0);
			}
			else
				count++;
		}
	}
	
	private boolean checkAlloc(boolean[] complete_alloc,double[][] alloc)
	{
		for(int loopi = 0; loopi < complete_alloc.length;loopi++)
		{
			if(complete_alloc[loopi] && alloc[hello.agent][loopi] < 0.99)
				return false;
		}
		return true;
	}
	
	private boolean existIncAlloc(boolean[] complete_alloc,double[][] alloc)
	{
		for(int loopi = 0; loopi < complete_alloc.length;loopi++)
		{
			if(!complete_alloc[loopi] && alloc[hello.agent][loopi] < 0.99 && alloc[hello.agent][loopi] > 0)
				return true;
		}
		return false;
	}
	
	
	private void updateJ_plus(Vector<Integer> J_plus, double epsilon)
	{
		Iterator<Integer> iter = J_plus.iterator();
		while(iter.hasNext())
		{
			//System.out.println("updating j plus");
			int j = iter.next();
			//System.out.println("j plus = " + j);
			//System.out.println("before update prices[j] = " + prices[j]);
			prices[j] = prices[j] * (1 + PJ_minus*epsilon);
			//System.out.println("after update prices[j] = " + prices[j]);
		}
	}
	
	private void updateJ_minus(Vector<Integer> J_minus, double epsilon)
	{
		Iterator<Integer> iter = J_minus.iterator();
		while(iter.hasNext())
		{
			int j = iter.next();
			prices[j] = prices[j] * (1 - PJ_plus*epsilon);
		}
	}
	
	private double getEpsilon1_plus_zero(Vector<Integer> S_plus, Vector<Integer>J_zero)
	{
		double ans = 100;
		Iterator<Integer> iterS = S_plus.iterator();
		while(iterS.hasNext())
		{
			Iterator<Integer> iterJ = J_zero.iterator();
			int s = iterS.next(); 
			while(iterJ.hasNext())
			{
				int j = iterJ.next();
				if(!edges[s][j])
				{
					double eps = Math.pow(PJ_minus, -1) * ((M[s]*prices[j]/U[s][j])-1);
					ans = Math.min(ans, eps);
				}
			}
		}
		//System.out.println("epsilon1 +0: " + ans);
		return ans;
	}
	
	private double getEpsilon1_zero_minus(Vector<Integer> S_zero, Vector<Integer>J_minus)
	{
		double ans = 100;
		Iterator<Integer> iterS = S_zero.iterator();
		while(iterS.hasNext())
		{
			Iterator<Integer> iterJ = J_minus.iterator();
			int s = iterS.next(); 
			while(iterJ.hasNext())
			{
				int j = iterJ.next();
			//	System.out.println("epsilon1 0- U[s][j]: " + edges[s][j]);
				if(!edges[s][j])
				{
					double eps = Math.pow(PJ_plus, -1) * (1- U[s][j]/(M[s]*prices[j]));
				//	System.out.println("eps = " + eps);
					ans = Math.min(ans, eps);
				}
			}
		}
		//System.out.println("epsilon1 0-: " + ans);
		return ans;
	}
	
	private double getEpsilon1_plus_minus(Vector<Integer> S_plus, Vector<Integer>J_minus)
	{
		//System.out.println("starting ");
		double ans = 100;
		Iterator<Integer> iterS = S_plus.iterator();
		while(iterS.hasNext())
		{
			Iterator<Integer> iterJ = J_minus.iterator();
			int s = iterS.next(); 
			while(iterJ.hasNext())
			{
				int j = iterJ.next();
				//System.out.println("s = " + s + " j = " + j + " (U[s][j]*PJ_minus + M[s]*prices[j]*PJ_plus) = " + (U[s][j]*PJ_minus + M[s]*prices[j]*PJ_plus));
				if(!edges[s][j])
				{
					double eps =  (M[s]*prices[j]-U[s][j])/(U[s][j]*PJ_minus + M[s]*prices[j]*PJ_plus);
					//System.out.println("epsilon1 +-: " + eps);
					ans = Math.min(ans, eps);
				}
			}
		}
		//System.out.println("ans +-: " + ans);
		return ans;
	}
	
	private double getEpsilon2(Vector<Integer> S_minus,Vector<Integer> J_minus)
	{
		double ans = 100;
		Vector<Vector<Integer>> subsets = getSubsets(S_minus);
		//System.out.println("subsets: " + subsets);
		Iterator<Vector<Integer>> iter = subsets.iterator();
		while(iter.hasNext())
		{
			Vector t = iter.next();
			if(t.size() > 0)
			{
			
				double alphaT = getSetAlphas(t);
				Vector<Integer> jT = getJset(t,J_minus);
				double pJT = getSetPrices(jT);
				//System.out.println("t: " + t);
				//System.out.println("alphaT: " + alphaT);
				//System.out.println("jT: " + jT);
				//System.out.println("pJT: " + pJT);
				
				double eps2 = (pJT-alphaT)/(PJ_plus*pJT);
				//System.out.println("eps2 = " + eps2);
				ans = Math.min(ans, eps2);
			}
		}
		return ans;
	}
	
	private Vector<Integer> getJset(Vector<Integer> t,Vector<Integer> J_minus)
	{
		Vector<Integer> ans = new Vector<Integer> ();
		Iterator<Integer> iter = t.iterator();
		while(iter.hasNext())
		{
			int s = iter.next();
			for(int i = 0; i < edges[s].length; i++)
				if(edges[s][i] && J_minus.contains(i))
					if(!ans.contains(i))
						ans.add(i);
		}
		return ans;
	}
	
	private double getSetPrices(Vector<Integer> set)
	{
		double ans = 0;
		Iterator<Integer> iter = set.iterator();
		while(iter.hasNext())
			ans = ans + prices[iter.next()];
		return ans;
	}
	
	private double getSetAlphas(Vector<Integer> set)
	{
		double ans = 0;
		Iterator<Integer> iter = set.iterator();
		while(iter.hasNext())
			ans = ans + alphas[iter.next()];
		return ans;
	}
	
	private Vector<Vector<Integer>> getSubsets(Vector<Integer> S)
	{
		Vector<Vector<Integer>> subsets = new Vector<Vector<Integer>>();
		subsets.add(S);
		return getSubsetRec(subsets);
		
	}
	
	private Vector<Vector<Integer>> getSubsetRec(Vector<Vector<Integer>> subsets)
	{
		if(subsets.get(0).size() == 0)
			return subsets;
		else
		{
			Vector<Integer> v = subsets.remove(0);
			Integer i = v.remove(0);
			subsets.add(0,v);
			subsets = getSubsetRec(subsets);
			Vector<Vector<Integer>> ans = new Vector<Vector<Integer>>();
			Iterator<Vector<Integer>> iter = subsets.iterator();
			while(iter.hasNext())
			{
				Vector<Integer> v1 = iter.next();
				Vector<Integer> v2 = new Vector<Integer>(v1);
				v1.add(i);
				ans.add(v1);
				ans.add(v2);
			}
			return ans;
		}
	}
	
	private double getPJ( Vector<Integer> vJ)
	{
		double ans = 0;
		Iterator<Integer> iter = vJ.iterator();
		int ind = -1;
		while(iter.hasNext())
		{
			ind = iter.next();
			ans = ans + prices[ind];
		}
		return ans;
	}
	public static double[] getAlphas(double[][] U)
	{
		double[] ans = new double[U.length];
		for(int i = 0; i < ans.length; i++)
			ans[i] = 1/(double)ans.length;
		return ans;
	}
	
	public static double[] getInitPrices(double[][] U)
	{
		double[] maxA = getMaxArr(U);
		double[] ans = new double[maxA.length];
		double sum = 0;
		for(int i = 0; i < maxA.length;i++)
		{
			sum = sum + maxA[i];
		}
		//System.out.println(sum);
		for(int j = 0; j < maxA.length;j++)
		{
			//System.out.println(maxA[j]);
			ans[j] = (maxA[j]/(double)sum);
			//System.out.println(ans[j]);
		}
		return ans;
	}
	
	//gets uniform prices
	/*
	private double[] getInitPrices()
	{
	//	int[] maxA = getMaxArr();
		double[] ans = new double[U[0].length];
		
		for(int j = 0; j < U[0].length;j++)
		{
			//System.out.println(maxA[j]);
			ans[j] = 1/(double)U[0].length;
			//System.out.println(ans[j]);
		}
		System.out.println("init prices: ");
		hello.printDoubleArray(ans);
		return ans;
	}
	*/
	
	private static double[] getMaxArr(double[][] U)
	{
		double[] ans = new double[U[0].length];
		for(int j = 0; j < U[0].length;j++)
		{
			double max = 0;
			for(int i = 0; i < U.length;i++)
			{
				if(U[i][j] > max)
					max = U[i][j];
			}
			ans[j] = max;
		}
		return ans;
	}
	
	//gets the minimal utility for each item
	/*
	public int[] getMaxArr()
	{
		int[] ans = new int[U[0].length];
		for(int j = 0; j < U[0].length;j++)
		{
			int max = 100;
			for(int i = 0; i < U.length;i++)
			{
				if(U[i][j] < max)
					max = U[i][j];
			}
			ans[j] = max;
		}
		return ans;
	}
	*/
	private static int[][] copyIntSquareArr(int[][] db)
	{
		//System.out.println("db.length - "+ db.length);
		//System.out.println("db[0].length - "+ db[0].length);
		//hello.printBooleanDoubleArray(db);
		int[][] ans = new int[db.length][db[0].length];
		for (int i = 0;i < db.length;i++)
		{
			//System.out.println(i);
			//System.out.println(db[i].length);
			for (int j = 0;j < db[i].length;j++)
				ans[i][j] = db[i][j];
		}
		return ans;
	}
	
	private static double[][] copyDoubleSquareArr(double[][] db)
	{
		//System.out.println("db.length - "+ db.length);
		//System.out.println("db[0].length - "+ db[0].length);
		//hello.printBooleanDoubleArray(db);
		double[][] ans = new double[db.length][db[0].length];
		for (int i = 0;i < db.length;i++)
		{
			//System.out.println(i);
			//System.out.println(db[i].length);
			for (int j = 0;j < db[i].length;j++)
				ans[i][j] = db[i][j];
		}
		return ans;
	}
	
	public static double[] getMArr(double[] price, double[][] U)
	{
	//	System.out.println("starting getMArr with: ");
	//	hello.printDoubleArray(price);
	//	System.out.println("U:  ");
	//	hello.printDoubleArray(U);
		double[] ans = new double[U.length];
		for(int i = 0; i < U.length;i++)
		{
			double max = 0;
			for(int j = 0; j < U[i].length;j++)
			{
		//		System.out.println("U[i][j]: " + U[i][j]);
				if(U[i][j]/price[j] > max)
					max = U[i][j]/price[j];
			//	System.out.println("max " + max);
			}
			ans[i] = max;
		}
	//	System.out.println("Finishing getMArr with: ");
	//	hello.printDoubleArray(ans);
		return ans;
	}
	
	public static boolean[][] getEdges(double[] price, double[] M, double[][] U)
	{
		//System.out.println("edges:");
		boolean[][] ans = new boolean[U.length][U[0].length];
		for(int i = 0; i < U.length;i++)
		{
			for(int j = 0; j < U[i].length;j++)
			{
				//System.out.println("U[i][j]/price[j] = " + U[i][j]/price[j]);
				if(Math.abs(U[i][j]/price[j] - M[i]) < 0.0000001)
					ans[i][j] = true;
			}
		}
		//hello.printBooleanDoubleArray(ans);
		//System.out.println("::::::::::::::::::");
		return ans;
	}
	
	private Vector<Pair> getMaxCycle(Vector<Vector<Pair>> cycles)
	{
		Vector<Pair> maxCycle = null;
		Vector<Pair> temp;
		double max = 0;
		Iterator<Vector<Pair>> iter_cycle = cycles.iterator();
		while(iter_cycle.hasNext())
		{
			temp = iter_cycle.next();
			Iterator<Pair> iter_pair = temp.iterator();
			Pair temp_pair1 = temp.lastElement();
			Pair temp_pair2 = temp.get(0);
			double mone = U[temp_pair2.getFirst()][temp_pair1.getSecond()];
			double mechane = U[temp_pair2.getFirst()][temp_pair2.getSecond()];	
			iter_pair.next();
			while(iter_pair.hasNext())
			{
				temp_pair1 = temp_pair2;
				temp_pair2 = iter_pair.next();
				mone = mone * U[temp_pair2.getFirst()][temp_pair1.getSecond()];
				mechane = mechane * U[temp_pair2.getFirst()][temp_pair2.getSecond()];
			}
			if(mone/mechane > max)
			{
			//	System.out.println("updating max cycle  = " + temp); 
			//	System.out.println("updating max cycle with mone  = " + mone + ", mechane = " + mechane); 
				maxCycle = temp;
				max = mone/mechane;
			}
			
		}
		return maxCycle;
	}
	
	private Vector<Pair> getMaxCycle(Vector<Vector<Pair>> cycles, int agent, int item)
	{
		Vector<Pair> maxCycle = null;
		Vector<Pair> temp;
		double max = 0;
		Iterator<Vector<Pair>> iter_cycle = cycles.iterator();
		while(iter_cycle.hasNext())
		{
			boolean includesItem = false;
			temp = iter_cycle.next();
			Iterator<Pair> iter_pair = temp.iterator();
			Pair temp_pair1 = temp.lastElement();
			Pair temp_pair2 = temp.get(0);
			if(temp_pair2.getFirst() == agent && temp_pair2.getSecond() == item)
				includesItem = true;
			double mone = U[temp_pair2.getFirst()][temp_pair1.getSecond()];
			double mechane = U[temp_pair2.getFirst()][temp_pair2.getSecond()];	
			iter_pair.next();
			while(iter_pair.hasNext())
			{
				temp_pair1 = temp_pair2;
				temp_pair2 = iter_pair.next();
				if(temp_pair2.getFirst() == agent && temp_pair2.getSecond() == item)
					includesItem = true;
				mone = mone * U[temp_pair2.getFirst()][temp_pair1.getSecond()];
				mechane = mechane * U[temp_pair2.getFirst()][temp_pair2.getSecond()];
			}
			if(mone/mechane > max && includesItem)
			{
			//	System.out.println("updating max cycle  = " + temp); 
			//	System.out.println("updating max cycle with mone  = " + mone + ", mechane = " + mechane); 
				maxCycle = temp;
				max = mone/mechane;
			}
			
		}
		return maxCycle;
	}
	
	private int getRedItem(int ind, Vector<Pair> cycle)
	{
		Iterator<Pair> iter = cycle.iterator();
		while(iter.hasNext())
		{
			Pair p = iter.next();
			if(p.getFirst() == ind)
				return p.getSecond();
		}
		return -1;
	}
	
	private double getMaxRed(int ind, int item, Vector<Pair> cycle)
	{
		//System.out.println("starting getMaxRed on cycle: " + cycle);
		Pair temp_pair1 = cycle.lastElement();
		Pair temp_pair2 = cycle.get(0);
		Iterator<Pair> iter_pair = cycle.iterator();
		double mone = U[temp_pair2.getFirst()][temp_pair1.getSecond()];
		double mechane = U[temp_pair2.getFirst()][temp_pair2.getSecond()];	
		iter_pair.next();
		while(iter_pair.hasNext())
		{
			temp_pair1 = temp_pair2;
			temp_pair2 = iter_pair.next();
			mone = mone * U[temp_pair2.getFirst()][temp_pair1.getSecond()];
			mechane = mechane * U[temp_pair2.getFirst()][temp_pair2.getSecond()];
		}
		
		Iterator<Pair> iter = cycle.iterator();
		while(iter.hasNext())
		{
			Pair p = iter.next();
			if(p.getFirst() == ind && p.getSecond() == item)
			{
				//System.out.println("updating max reduction with mone  = " + mone + ", mechane = " + mechane); 
				mechane = mechane/U[p.getFirst()][p.getSecond()];
				//System.out.println("after dividing mone  = " + mone + ", mechane = " + mechane); 
				double x = mone / mechane;
				return U[p.getFirst()][p.getSecond()] - x;
			}
		}
		return -1;
	}
	
    private void getMaxReductions(int i, int j)
		{
		    //System.out.println("started binary (new) get max reductions");
			double[][] temp_alloc = FN.getAlloc();
			//double[][] temp_U = copyDoubleSquareArr(U);
			
			
			if(temp_alloc[i][j] > 0.99999999)
			    {
				double dif = U[i][j] / 2;
				for (int c = 0; c < 10; c++)
				    {
					if(temp_alloc[i][j] > 0.99999999)
					    U[i][j] = U[i][j] - dif;
					else
					    U[i][j] = U[i][j] + dif;
					getMinCutVal();
					
					temp_alloc = FN.getAlloc();
					dif = dif/2;
				    }
			    }			
			
			
			//return U;
		}
    
    /*
		private double[][] getMaxReductions(Flow_net FN)
		{
		    System.out.println("started get max reductions");
			double[][] ans = new double[alphas.length][prices.length];
			for(int i = 0; i < alphas.length; i++)
			{				
			    System.out.println("started loopi");
				Vector<Vector<Pair>> cyclesContS = FN.cyclesContaining(i);
				System.out.println("got cycles");
				for(int j = 0; j < prices.length;j++){
					Vector<Pair> maxCycle = getMaxCycle(cyclesContS,i,j);  //gets the cycle with the highest ratio in which s is in.
					System.out.println("max cycle = " + maxCycle); 
					//int redItem = getRedItem(i,maxCycle);
					//System.out.println("reduction item = " + redItem);
					if(maxCycle != null){
						double maxRed = getMaxRed(i,j,maxCycle);
						//System.out.println("max reduction = " + maxRed);
						ans[i][j] = maxRed;
					}
				}
			}
			return ans;
		}
    */
		/*
		// old method from 12_4_2009
		private double[][] getMaxReductions(Flow_net FN)
		{
			double[][] ans = new double[alphas.length][prices.length];
			for(int i = 0; i < alphas.length; i++)
			{				
				Vector<Vector<Pair>> cyclesContZero = FN.cyclesContaining(i);
				Vector<Pair> maxCycle = getMaxCycle(cyclesContZero);
				//System.out.println("max cycle = " + maxCycle); 
				int redItem = getRedItem(i,maxCycle);
				//System.out.println("reduction item = " + redItem); 
				double maxRed = getMaxRed(i,redItem,maxCycle);
				//System.out.println("max reduction = " + maxRed);
				ans[i][redItem] = maxRed;
			}
			return ans;
		}
		*/
		
		private int[] getTypes(Flow_net FN)
		{
			int[] ans = new int[alphas.length];
			double[][] alloc = FN.getAlloc();
			for(int i = 0; i < ans.length; i++)
			{
				int count_allocs = 0;
				for(int j = 0; j < prices.length;j++)
				{
					if(alloc[i][j] > 0.9999999)
						ans[i] = 1;
					else
						if(alloc[i][j] > 0)
							count_allocs++;
				}
				if(ans[i] == 0)
				{
					if(count_allocs > 1)
						ans[i] = 2;
				}
			}
			return ans;	
		}
		
		private boolean canReduce()
		{
			int rand = (int)(Math.random() * U.length);
			for(int i = 0; i < U.length; i++)
			{
				int ind = (rand + i)%U.length;
				if(types[ind] < 2)
				{
					for(int j = 0; j < U[ind].length; j++)
					{
						if(maxReductions[ind][j] > 1)
						{
							U[ind][j] = U[ind][j] - (int)maxReductions[ind][j];
							//System.out.println("reducing " + (int)maxReductions[ind][j] + " for " + ind );
							return true;
						}
					}
				}
			}
			/*
			for(int i = 0; i < U.length; i++)
			{
				int ind = (rand + i)%U.length;
				if(types[ind] == 0)
				{
					for(int j = 0; j < U[ind].length; j++)
					{
						if(maxReductions[ind][j] >= 1)
						{
							U[ind][j] = U[ind][j] - (int)maxReductions[ind][j];
							System.out.println("reducing " + (int)maxReductions[ind][j] + " for " + ind );
							return true;
						}
					}
				}
			}
				*/	
			return false;		
		}
}
